#include <msd/dispatcher.h>
#include <msd/iomanager.h>
#include <msd/tcpserver.h>
#include <msd/debug.h>

using namespace MSD;

static Dispatcher *_instance;

IOManager *Dispatcher::ioManager()
{
	return mIOManager;
}

Dispatcher *Dispatcher::the()
{
	return _instance;
}

Dispatcher::Dispatcher()
{
	assert(!_instance);
	_instance = this;

	mIOManager = new StdIOManager;
	TCPServer::setPort(17771);
	tcpServer = new TCPServer(this);
}

Dispatcher::~Dispatcher()
{
	delete mIOManager;
	delete tcpServer;
	assert(_instance);
	_instance = 0;
}

void Dispatcher::run()
{
	mIOManager->run();
}
