#include <msd/msd.h>
#include <msd/bucket.h>

namespace MSD {

class Marshaller {
private:
	Bucket *mBucket;

public:
	Marshaller(Bucket *bucket)
		: mBucket(bucket)
	{
	}

	void writeInt(int i) {
		unsigned char *data = mBucket->write(4);
		data[0] = (i >> 24) & 0xff;
		data[1] = (i >> 16) & 0xff;
		data[2] = (i >> 8) & 0xff;
		data[3] = i & 0xff;
	}

	void writeInt64(int64 i) {
		unsigned char *data = mBucket->write(8);
		data[0] = (i >> 56) & 0xff;
		data[1] = (i >> 48) & 0xff;
		data[2] = (i >> 40) & 0xff;
		data[3] = (i >> 32) & 0xff;
		data[4] = (i >> 24) & 0xff;
		data[5] = (i >> 16) & 0xff;
		data[6] = (i >> 8) & 0xff;
		data[7] = i & 0xff;
	}

	unsigned char *writeByteArray(int length)
	{
		writeInt(length);
		return mBucket->write(length);
	}
};

}
